package tictactoe.learn;

import tictactoe.core.Position;
import tictactoe.core.Status;

public class MoveDatabase {
	private HashTable<Position,Outcomes> table;
	
	public final static int MULTIPLIER_OFFSET = Position.SIZE * Position.SIZE;
	
	public MoveDatabase() {
		table = new HashTable<>();
	}
	
	public void recordOutcome(Position p, Status outcome, int stepsFromEnd) {
		if (!table.containsKey(p)) {
			addDefault(p);
		}
		table.get(p).bump(outcome, MULTIPLIER_OFFSET - stepsFromEnd);
	}
	
	public Outcomes getOutcomes(Position p) {
		if (!table.containsKey(p)) {
			addDefault(p);
		}
		return table.get(p);
	}
	
	private void addDefault(Position p) {
		Outcomes start = new Outcomes();
		start.bump(Status.X_WIN, MULTIPLIER_OFFSET - 1);
		start.bump(Status.O_WIN, MULTIPLIER_OFFSET - 1);
		table.put(p, start);
	}
}
